"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const find_1 = require("@crudjs/crud-request/find");
const find_trans_1 = require("./find-trans");
describe('trans-find', () => {
    it('should ok', () => {
        const params = {
            fields: ['id', 'name.first', 'name.last', 'email'],
            join: [
                { field: 'company', select: ['name'] },
                { field: 'company.projects', select: ['name', 'isActive'] },
                { field: 'profile', select: ['name'] },
            ],
            search: {
                id: { $gt: 3 },
                isActive: true,
                'company.id': 1,
            },
            sort: [['profile.name', 'DESC']],
            offset: 0,
            limit: 5,
            resetCache: true,
            includeDeleted: 1,
        };
        const findOptions = {
            select: {
                id: true,
                name: {
                    first: true,
                    last: true,
                },
                email: true,
                company: {
                    name: true,
                    projects: {
                        name: true,
                        isActive: true,
                    },
                },
                profile: {
                    name: true,
                },
            },
            relations: {
                company: {
                    projects: true,
                },
                profile: true,
            },
            where: {
                id: find_1.OP.MoreThan(3),
                isActive: true,
                company: { id: 1 },
            },
            order: { profile: { name: 'DESC' } },
            take: 5,
            skip: 0,
            cache: false,
            withDeleted: true,
        };
        expect((0, find_trans_1.findTrans)(findOptions)).toEqual(params);
    });
});
//# sourceMappingURL=find-trans.spec.js.map