"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deepSetFieldsAndJoin = void 0;
const crud_util_1 = require("@crudjs/crud-util");
const join_map_utils_1 = require("../utils/join-map.utils");
function deepSetFieldsAndJoin(findOptions) {
    const m = new join_map_utils_1.JoinMapUtils();
    const fields = [];
    const relations = findOptions.relations;
    const deepSetJoin = (relations, parents = []) => {
        (0, crud_util_1.objKeys)(relations).forEach((relationTable) => {
            const relationOpt = relations[relationTable];
            if (!relationOpt)
                return;
            m.setJoin([...parents, relationTable]);
            if (!(0, crud_util_1.isBoolean)(relationOpt)) {
                deepSetJoin(relationOpt, [...parents, relationTable]);
            }
        });
    };
    if (relations)
        deepSetJoin(relations);
    const deepSetRelationFields = (relationSelect, fieldChain) => {
        const relationFields = [];
        (0, crud_util_1.objKeys)(relationSelect).forEach((relationField) => {
            const item = relationSelect[relationField];
            if ((0, crud_util_1.isTrue)(item)) {
                relationFields.push(relationField);
            }
            else if (!(0, crud_util_1.isBoolean)(item)) {
                deepSetRelationFields(item, fieldChain.concat(relationField));
            }
        });
        m.setJoinSelect(fieldChain, relationFields);
    };
    const deepSetFields = (select, parents = []) => {
        (0, crud_util_1.objKeys)(select).forEach((field) => {
            const selectOpt = select[field];
            const fieldChain = [...parents, field];
            if (!selectOpt)
                return;
            if ((0, crud_util_1.isTrue)(selectOpt))
                fields.push(fieldChain.join('.'));
            else {
                if (m.isJoin(fieldChain)) {
                    deepSetRelationFields(selectOpt, fieldChain);
                }
                else {
                    deepSetFields(selectOpt, fieldChain);
                }
            }
        });
    };
    if (findOptions.select)
        deepSetFields(findOptions.select);
    return { fields, join: m.getJoins() };
}
exports.deepSetFieldsAndJoin = deepSetFieldsAndJoin;
//# sourceMappingURL=fields-and-join.js.map