"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deepSetSort = void 0;
const crud_util_1 = require("@crudjs/crud-util");
const type_utils_1 = require("../utils/type.utils");
function deepSetSort(order, parents = []) {
    if (!order)
        return undefined;
    let sort = [];
    (0, crud_util_1.objKeys)(order).forEach((field) => {
        const item = order[field];
        const fieldChain = parents.concat(field);
        if ((0, type_utils_1.isFindOptionsOrder)(item)) {
            sort = sort.concat(deepSetSort(item, fieldChain));
        }
        else if (typeof item !== 'object') {
            const desc = ['DESC', 'desc', 1];
            sort.push([fieldChain.join('.'), desc.includes(item) ? 'DESC' : 'ASC']);
        }
        else {
            sort.push([fieldChain.join('.'), item.direction.toUpperCase()]);
        }
    });
    return sort;
}
exports.deepSetSort = deepSetSort;
//# sourceMappingURL=sort.js.map