"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JoinMapUtils = void 0;
class JoinMapUtils {
    constructor() {
        this.joins = new Map();
    }
    getJoins() {
        return Array.from(this.joins.values());
    }
    isJoin(field) {
        if (Array.isArray(field))
            field = field.join('.');
        return this.joins.has(field);
    }
    setJoin(field, value) {
        if (Array.isArray(field))
            field = field.join('.');
        this.joins.set(field, value || { field });
    }
    setJoinSelect(field, select) {
        if (Array.isArray(field))
            field = field.join('.');
        const join = this.joins.get(field);
        if (join)
            join.select = select;
    }
}
exports.JoinMapUtils = JoinMapUtils;
//# sourceMappingURL=join-map.utils.js.map